CON

    Baro_Addr = $EE  'i2c address of baro sensor

OBJ
   i2cObject      : "ECi2c"

VAR
   byte Baro_Data_f6
   byte Baro_Data_f7
   byte Baro_Data_f8
   byte Baro_Data_f9
   byte Baro_Data_fa
   byte Baro_Data_fb
   byte Baro_Data_fc
   byte Baro_Data_fd
   byte Baro_Data_fe
   byte Baro_Data_ff
   byte Baro_Data_11
   byte Baro_Data_12
   long _220uS
   long _40uS
   byte i2cSCL, i2cSDA
PUB init(_scl, _sda)
   i2cSCL := _scl
   i2cSDA := _sda
   i2cObject.Init(i2cSDA, i2cSCL)
   _220uS := clkfreq / 100_000 * 22 
   _40uS := clkfreq / 100_000 * 4 

PUB start_adcTemp
  i2cObject.i2cStart
   waitcnt(_40uS+cnt)
   i2cObject.writelocation(Baro_Addr, $6e, $ee)   'start conversion 0xee 0x6e 0xee temp sequence
   waitcnt(_40uS+cnt)
   i2cObject.i2cStop

PUB start_adcPres
  i2cObject.i2cStart
   waitcnt(_40uS+cnt)
   i2cObject.writelocation(Baro_Addr, $F4, $ea)   'start conversion 0xee 0xf4 0xea press sequence
   waitcnt(_40uS+cnt)
   i2cObject.i2cStop

  
PUB readBaro | data[10]    'get 10 bytes of data in a row into data[xx]

  i2cObject.i2cStart
   i2cObject.i2cWrite(Baro_Addr)         'write 0xEE to i2c bus   sensor write address
'   waitcnt(_40uS+cnt)
   i2cObject.i2cWrite($F6)               'write 0xF6 to i2c bus   sensor register
'   waitcnt(_40uS+cnt)
  i2cObject.i2cStart                     'do a restart
'   waitcnt(_40uS+cnt)
   i2cObject.i2cWrite(Baro_Addr|1)       'write 0xEF to i2c bus   sensor read address   
'   waitcnt(_40uS+cnt)
   data[0] := (i2cObject.i2cRead(0))         'i2c read with ack bit
   data[1] := (i2cObject.i2cRead(0)) 
   data[2] := (i2cObject.i2cRead(0))
   data[3] := (i2cObject.i2cRead(0))
   data[4] := (i2cObject.i2cRead(0))
   data[5] := (i2cObject.i2cRead(0))
   data[6] := (i2cObject.i2cRead(0))
   data[7] := (i2cObject.i2cRead(0))
   data[8] := (i2cObject.i2cRead(0))
   data[9] := (i2cObject.i2cRead(0))
   data[10] := (i2cObject.i2cRead(0))
   data[11] := (i2cObject.i2cRead(1))        'i2c read with nack bit
   i2cObject.i2cStop
   
   Baro_Data_f6 := data[0] 
   Baro_Data_f7 := data[1]
   Baro_Data_f8 := data[2] 
   Baro_Data_f9 := data[3] 
   Baro_Data_fa := data[4]
   Baro_Data_fb := data[5] 
   Baro_Data_fc := data[6]
   Baro_Data_fd := data[7] 
   Baro_Data_fe := data[8] 
   Baro_Data_ff := data[9] 
   Baro_Data_11 := data[10] 
   Baro_Data_12 := data[11] 


PUB Baro_f6
   return Baro_Data_f6

PUB Baro_f7
   return Baro_Data_f7

PUB Baro_f8
   return Baro_Data_f8

PUB Baro_f9
   return Baro_Data_f9

PUB Baro_fa
   return Baro_Data_fa

PUB Baro_fb
   return Baro_Data_fb

PUB Baro_fc
   return Baro_Data_fc

PUB Baro_fd
   return Baro_Data_fd

PUB Baro_fe
   return Baro_Data_fe

PUB Baro_ff
   return Baro_Data_ff

PUB Baro_11
   return Baro_Data_11

PUB Baro_12
   return Baro_Data_12